# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

package SROFF;

%::map = (%::map,
	  "LINUXDOC", "Holder",
	  "ARTICLE", "Holder",
	  "APPENDIX", "Holder",
	  "TITLEPAG", "LDTitlePage",
	  "TITLE", "Title",
	  "HEADING", "Title",
	  "AUTHOR", "Holder",
	  "NAME", "Holder",
	  "DATE", "Holder",
	  "ABSTRACT", "LDAbstract",
	  "TOC", "Drop",
	  "SECT", "Section",
	  "SECT1", "Section",
	  "SECT2", "Section",
	  "SECT3", "Section",
	  "SECT4", "Section",

	  "TABLE", "Holder",
	  "TABULAR", "LDTabular",
	  "COLSEP", "LDColSep",
	  "ROWSEP", "LDRowSep",

	  "P", "Paragraph",
	  "QUOTE", "BlockQuote",
	  "TSCREEN", "Screen",
	  "VERB", "Screen",
	  "CODE", "Screen",

	  "F", "Holder",

	  "DESCRIP", "VariableList",
	  "TAG", "LDTerm",
	  "ITEMIZE", "ItemizedList",
	  "ENUM", "OrderedList",
	  "ITEM", "LDListItem",

	  "TT", "InlineQuotedTT",
	  "IT", "InlineItalic",
	  "EM", "InlineItalic",
	  "SF", "Inline",
	  "SL", "InlineItalic",
	  "URL", "LDURL",
	  "BF", "InlineBold",
	  "CPARAM", "InlineItalic",

	  "REF", "Drop",
	  "LABEL", "Drop",

	  "NEWLINE", "Drop",
	  );

sub InitDTD {
}

sub enLDTabular {
    my ($self, @rest) = @_;
    
    if (ref ($self) =~ /HTML|ASCII/) {
	$self->enScreen(@rest);
    }
}
sub lvLDTabular {
    my ($self, @rest) = @_;
    
    if (ref ($self) =~ /HTML|ASCII/) {
	if (substr($self->{data}, -1) ne "\n") {
	    $self->{data} .= "\n";
	}
	open (DUMP, "| tbl | nroff | col -bfx >tbl$level.tmp");
	print DUMP ".TS\n";
	print DUMP "$attribute_value{$level,'CA'}.\n";
	print DUMP $data;
	print DUMP ".TE\n";
	close (DUMP);
	open (DUMP, "tbl$level.tmp");
	sysread (DUMP, $data, 100000);
	close (DUMP);
	unlink ("tbl$level.tmp");
	$self->lvScreen(@rest);
    }
}

sub enLDColSep {
}
sub lvLDColSep {
    my ($self, @rest) = @_;
    
    $self->{data} = "\t";
}

sub enLDRowSep {
}
sub lvLDRowSep {
    my ($self, @rest) = @_;
    
    $self->{data} = "\n";
}

sub enLDAbstract {
    my ($self, @rest) = @_;
    
    $self->enAbstract(@rest);
    $self->enParagraph(@rest);
}
sub lvLDAbstract {
    my ($self, @rest) = @_;
    
    $self->lvParagraph(@rest);
    $self->lvAbstract(@rest);
}

sub enLDTerm {
}
sub lvLDTerm {
    my ($self, @rest) = @_;
    
    if (ref ($self) =~ /ASCII/) {
	$self->{data} = "\0" . $self->{data} . "\0";
    } elsif (ref ($self) =~ /HTML/) {
	$self->{data} = "\n<DT>$self->{data}<DD>\n";
    } elsif (ref ($self) =~ /RTF/) {
	unshift (@{$self->{indent}}, $self->{indent}[0] - 720);
	unshift (@{$self->{spaceAfter}}, 0);
	$self->{data} = $self->rtfParStart . "\\keepn $self->{data}\\par\1";
	shift (@{$self->{indent}});
	shift (@{$self->{spaceAfter}});
    }
}
sub enLDListItem {
    my ($self, @rest) = @_;
    
    $self->enListItem(@rest);
#    &enParagraph;
}
sub lvLDListItem {
    my ($self, @rest) = @_;
    
#    &lvParagraph;
    $self->lvListItem(@rest);
}

sub enLDTitlePage {
    my ($self, @rest) = @_;
    
    $self->map ("TITLE", "StructTitle",
		    "NAME", "LDAuthor",
		    "DATE", "StructDate",
		    );
}
sub lvLDTitlePage {
    my ($self, @rest) = @_;
    
    $self->StructTitlePage(@rest);
    $self->unmap ("TITLE", "NAME", "DATE");
}

sub enLDAuthor {
    my ($self, @rest) = @_;
    
    $self->enStructAuthor(@rest);
}
sub lvLDAuthor {
    my ($self, @rest) = @_;
    
    $self->lvStructAuthor(@rest);
}

sub enLDURL {
}
sub lvLDURL {
    my ($self, @rest) = @_;
    
    if ($::attribute_value{$::level, 'NAME'} ne "<\@\@urlnam>") {
	$self->URL ($::attribute_value{$::level, 'NAME'},
		    $::attribute_value{$::level, 'URL'});
    } else {
	$self->URL ("", $::attribute_value{$::level, 'URL'});
    }
}

1;
