# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require Referable;

package Referable::Doc;

# SLOTS
#     title, subTitle, date, copyright -- Formatted string
#
#     abstract, otherInfo -- Formatted block
#       A paragraph or longer bits of info
#
#     authors -- array of hashes
#       author -- Formatted string
#       affiliation -- Formatted string
#

sub new {
    my ($type, %args) = @_;

    $self = new Referable (%args);

    bless $self;
}

sub fmtFull {
    my ($self) = @_;

    return ("$self->{type} $self->{index}.  $self->{title}");
}

sub fmtReference {
    my ($self, $context) = @_;

    return ("$self->{type} $self->{index}, "
	    . $context->InlineItalic($self->{title}));
}

1;
