# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

package Referable;

#
# SLOTS
#
#     Referables are used by element formatters, the slots within a
#     referable are really ``owned'' by them.
#
#     title
#        Title of this referable.  Printable.
#
#     type
#        Type (figure, section, etc.) of this referable.  Printable.
#
#     index
#        Styled-index ("1, 2, 3", "1-1, 1-2, 1-3", etc.).  Printable.
#
#     id
#        User-specified ID of this referable

sub new {
    my ($type, %args) = @_;

    $self = \%args;

    bless $self;
}

sub title {
    my ($self, $title) = @_;

    $self->{title} = $title;
}

sub fmtFull {
    my ($self) = @_;

    return ("$self->{type} $self->{index}.  $self->{title}");
}

sub fmtReference {
    my ($self, $context) = @_;

    return ("$self->{type} $self->{index}, "
	    . $context->InlineItalic($self->{title}));
}

1;
