# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Lists;

package SROFF::ASCII;

#
#
#

sub enList {
    my ($self, @rest) = @_;
    $self->SROFF::enList(@rest);
    unshift (@{$self->{indent}}, $self->{indent}[0] + 4);
}

sub lvList {
    my ($self, @rest) = @_;
    $self->{data} = "\01$self->{data}\01";
    if ($self->{filling}[1]) {
	$self->{data} = $self->nofill($self->{data});
    }
    shift (@{$self->{indent}});
    $self->SROFF::lvList(@rest);
}

#
#
#

#sub enOrderedList { &SROFF::enOrderedList(@_); }
#sub lvOrderedList { &SROFF::lvOrderedList(@_); }

#
#
#

#sub enItemizedList { &SROFF::enItemizedList(@_); }
#sub lvItemizedList { &SROFF::lvItemizedList(@_); }

#
# A variable, mark or glossary list
#

#sub enVariableList { &SROFF::enVariableList(@_); }
#sub lvVariableList { &SROFF::lvVariableList(@_); }

#
#
#

sub enListItem {
    my ($self, @rest) = @_;
    $self->SROFF::enListItem(@rest);
    $self->{itemnum}[0] ++;
    if ($self->{listType}[0] eq "ordered") {
	$self->{parHang}[0]
	    = $self->{indent}[0] - length ("$self->{itemnum}[0])");
    } elsif ($self->{listType}[0] eq "itemized") {
	$self->{parHang}[0] = $self->{indent}[0] - 2;
    }
    $self->{itemnum}[0] --;
}

sub lvListItem {
    my ($self, @rest) = @_;
    if ($self->{listType}[0] eq "ordered") {
	my $itemNum = $self->{itemnum}[0] + 1;
	$self->{data} = " " x ($self->{indent}[0] - 4)
	    . "$itemNum)" . $self->{data};
    } elsif ($self->{listType}[0] eq "itemized") {
	$self->{data} = " " x ($self->{indent}[0] - 4)
	    . " *" . $self->{data};
    }
    $self->SROFF::lvListItem(@rest);
}

#
#
#

#sub enTerm { &SROFF::enTerm(@_); }

sub lvTerm {
    my ($self, @rest) = @_;
    $self->{data} = "\0" . $self->{data} . "\0";
    $self->SROFF::lvTerm(@rest);
}

1;
