# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Paragraph;

package SROFF::ASCII;

#
#
#

sub enParagraph {
    my ($self, @rest) = @_;
    $self->SROFF::enParagraph(@rest);
    unshift (@{$self->{parHang}}, 0);
}

sub lvParagraph {
    my ($self, @rest) = @_;
    shift (@{$self->{parHang}});
    if ($self->{firstPara}[1]) {
        $self->{firstPara}[1] = 0;
	$self->{data} = $self->fill($self->{data}) . "\01";
	$self->{parHang}[0] = 0;
    } else {
	$self->{data} = "\01" . $self->fill($self->{data}) . "\01";
    }
    $self->SROFF::lvParagraph(@rest);
}

#
#
#

#sub enScreen { &SROFF::enScreen; }

sub lvScreen {
    my ($self, @rest) = @_;
#    $data =~ s/^(\s*\n)+//;
#    $data =~ s/(\n\s*)+$//;
    $self->{data} = "\01$self->{data}\01";
    if ($self->{filling}[0]) {
	$self->{data} = $self->nofill($self->{data});
    }
    $self->SROFF::lvScreen(@rest);
}

#
#
#

#sub enLineAnnotation { &SROFF::enLineAnnotation(@_); }
#sub lvLineAnnotation { &SROFF::lvLineAnnotation(@_); }

#
#
#

#sub enHolder { &SROFF::enHolder(@_); }
#sub lvHolder { &SROFF::lvHolder(@_); }

#
#
#

#sub enDrop { &SROFF::enDrop(@_); }
#sub lvDrop { &SROFF::lvDrop(@_); }

#
#
#

sub enBlockQuote {
    my ($self, @rest) = @_;
    $self->SROFF::enBlockQuote(@rest);
    unshift (@{$self->{indent}}, $self->{indent}[0]+4);
    unshift (@{$self->{rindent}}, $self->{rindent}[0]+4);
}

sub lvBlockQuote {
    my ($self, @rest) = @_;
    if ($self->{filling}[0]) {
	# snafu specific
	$self->{data} = "\01" . $self->fill($self->{data}) . "\01";
	shift (@{$self->{indent}});
	shift (@{$self->{rindent}});
	$self->{data} = $self->nofill($self->{data});
    } else {
	shift (@{$self->{indent}});
	shift (@{$self->{rindent}});
    }
    $self->SROFF::lvBlockQuote(@rest);
}

#
#
#

#sub enFigure { &SROFF::enFigure(@_); }
#sub lvFigure { &SROFF::lvFigure(@_); }

#
#
#

#sub enFigureTitle { &SROFF::enFigureTitle(@_); }

sub lvFigureTitle {
    my ($self, @rest) = @_;

    $self->{figure}->title ($self->{data});
    $self->{data} = "\01    " . $self->{figure}->fmtFull . "\01";
    $self->SROFF::lvFigureTitle(@rest);
}

#
#
#

#sub enFootnote { &SROFF::enFootnote(@_); }

sub lvFootnote {
    my ($self, @rest) = @_;
    # get rid of new-line formatting codes before formatting
    # in-line (note: this will leave internal new-line formatting
    # codes)
    $self->{data} =~ s/^\01?\036[0-9]+;[0-9]+;[0-9]+;((.|\n)*)\037\01$/\1/;
    $self->{data} = "(note: " . $self->{data} . ")";
    $self->SROFF::lvFootnote(@rest);
}

1;
