# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Structure;

package SROFF::ASCII;

#
#
#

#sub enStructTitle { &SROFF::enStructTitle(@_); }
#sub lvStructTitle { &SROFF::lvStructTitle(@_); }

#
#
#

#sub enStructSubTitle { &SROFF::enStructSubTitle(@_); }
#sub lvStructSubTitle { &SROFF::lvStructSubTitle(@_); }

#
#
#

#sub enStructDate { &SROFF::enStructDate(@_); }
#sub lvStructDate { &SROFF::lvStructDate(@_); }

#
#
#

#sub enStructAuthor { &SROFF::enStructAuthor(@_); }
#sub lvStructAuthor { &SROFF::lvStructAuthor(@_); }

#
#
#

sub StructTitlePage {
    my ($self, @rest) = @_;
    $self->{data} = "";

    ##
    ## Subject
    ##
    $self->{data} .= "\6" . $self->center($self->{docRef}[0]{title}) . "\2";
    $self->{data} .= $self->center($self->{docRef}[0]{subTitle})
	if (defined $self->{docRef}[0]{subTitle});
    $self->{data} .= "\4";

    ##
    ## Date
    ##
    if (defined $self->{docRef}[0]{date}) {
	$self->{data} .= "\02" . $self->center($self->{docRef}[0]{date})
	    . "\2";
    }

    ##
    ## Authors
    ##
    foreach $author (@{$self->{docRef}[0]{authors}}) {
	$self->{data} .= "\02";
	if ($author->{author} ne "") {
	    $self->{data} .= $self->center ($author->{author}) . "\01";
	}
	if (defined $author->{affiliation}) {
	    $self->{data} .= $self->center ($author->{affiliation}) . "\01";
	}
	$self->{data} .= "\02";
    }

    ##
    ## Abstract
    ##
    if (defined ($self->{docRef}[0]{abstract})) {
	$self->{data} .= "\02" . $self->center("ABSTRACT")
	    . "\01" . $self->{docRef}[0]{abstract};
    }

    # Will include other info and copyright
    $self->SROFF::StructTitlePage(@rest);
}

#
# Abstract
#

sub enAbstract {
    my ($self, @rest) = @_;
    $self->SROFF::enAbstract(@rest);
    $self->enBlockQuote(@rest);
}

sub lvAbstract {
    my ($self, @rest) = @_;
    $self->lvBlockQuote(@rest);
    $self->SROFF::lvAbstract(@rest);
}

#
#
#

#sub enSection { &SROFF::enSection(@_); }
#sub lvSection { &SROFF::lvSection(@_); }

#
#
#

#sub enTitle { &SROFF::enTitle(@_); }
sub lvTitle {
    my ($self, @rest) = @_;
    my ($sectionNum) = $#{$self->{sectionNum}} - 1;

    $self->{sectionRefs}[0]{title} = $self->{data};
    $self->{data} = "$self->{sectionRefs}[0]{index}  $self->{data}";
    $self->{data} = ("\4", "\3", "\2", "\1", "\1")[$sectionNum]
	. "$self->{data}\n"
	. $self->undertitle (("*", "=", "-", "-", " ")[$sectionNum],
			     $self->{data})
	. "\02";

    $self->SROFF::lvTitle(@rest);
}

1;
