# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::HTML::CharEntities;
require SROFF::HTML::Inline;
require SROFF::HTML::Lists;
require SROFF::HTML::Paragraph;
require SROFF::HTML::Structure;

package SROFF::HTML;

@ISA = (SROFF);

sub new {
    my $self;

    $self = new SROFF;

    bless $self;
}

sub Initialize {
    my ($self, @rest) = @_[0];

    $::backslash_in_data = "\\";

    $self->SROFF::Initialize (@rest);
}

sub PostProcess {
    my ($self, @rest) = @_;

    $self->{data} = $self->{dataStack}[0];
    $self->{data} =~ s/\035([^\035]*)\035/$self->fmtReference($1)/eg;
    # remove multiple empty paragraphs, replace with one as a separator
#    $self->{data} =~ s/(\s*<P>\s*<\/P>)+/<P><\/P>/g;
    # remove empty separator paragraph at end of paragraph
#    $self->{data} =~ s;\s*<P>\s*</P>\s*<(/P|/UL|/OL|/DL|LI)>;<\1>;g;
    # remove empty separator paragraph after end/start of paragraph
#    $self->{data} =~ s/\s*<(\/P|P)>\s*<P>\s*<\/P>/<\1>/g;
    $self->{data} = <<EOF;
<!DOCTYPE html PUBLIC "-//IETF//DTD HTML 2.0//EN">
<HTML>
  <HEAD>
    <TITLE>$self->{docRef}[0]{title}</TITLE>
  </HEAD>
  <BODY>
$self->{data}
  </BODY>
</HTML>
EOF

    $self->SROFF::PostProcess (@rest);
}

1;
