# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Lists;

package SROFF::HTML;

#
#
#

#sub enList { my ($self, @rest) = @_; $self->SROFF::enList(@rest); }

sub lvList {
    my ($self, @rest) = @_;

    # Space around list
#    $self->{data} = "<P></P>$self->{data}<P></P>";

    $self->SROFF::lvList(@rest);
}

#
#
#

#sub enOrderedList { &SROFF::enOrderedList(@_); }

sub lvOrderedList {
    my ($self, @rest) = @_;

    $self->{data} = "\n<OL>\n" . $self->{data} . "</OL>\n";

    $self->SROFF::lvOrderedList(@rest);
}

#
#
#

#sub enItemizedList { &SROFF::enItemizedList(@_); }

sub lvItemizedList {
    my ($self, @rest) = @_;

    $self->{data} = "\n<UL>\n" . $self->{data} . "</UL>\n";

    $self->SROFF::lvItemizedList(@rest);
}

#
# A variable, mark or glossary list
#

#sub enVariableList { &SROFF::enVariableList(@_); }
#sub lvVariableList { &SROFF::lvVariableList(@_); }

sub lvVariableList {
    my ($self, @rest) = @_;

    $self->{data} = "\n<DL>\n" . $self->{data} . "</DL>\n";

    $self->SROFF::lvVariableList(@rest);
}

#
#
#

#sub enListItem { my ($self, @rest) = @_; $self->SROFF::enListItem(@rest); }

sub lvListItem {
    my ($self, @rest) = @_;

    # remove paragraph around data
    $self->{data} =~ s/^<P>((.|\n)*)<\/P>\n$/\1/;
    if ($self->{listType}[0] eq "variable") {
#	$self->{data} = "\n<DD>$self->{data}<P></P>\n";
	$self->{data} = "\n<DD>$self->{data}\n";
    } else {
#	$self->{data} = "\n<LI>$self->{data}<P></P>\n";
	$self->{data} = "\n<LI>$self->{data}\n";
    }

    $self->SROFF::lvListItem(@rest);
}

#
#
#

#sub enTerm { &SROFF::enTerm(@_); }

sub lvTerm {
    my ($self, @rest) = @_;

    $self->{data} = "\n<DT>" . $self->{data};

    $self->SROFF::lvTerm(@rest);
}

1;
