# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Paragraph;

package SROFF::HTML;

#
#
#

#sub enParagraph { my ($self, @rest) = @_; $self->SROFF::enParagraph(@rest); }

sub lvParagraph {
    my ($self, @rest) = @_;

    if ($self->{firstPara}[0]) {
	$self->{firstPara}[0] = 0;
	# leave $data alone
    } else {
	$self->{data} = "<P>" . $self->{data} . "</P>\n";
    }

    $self->SROFF::lvParagraph(@rest);
}

#
#
#

#sub enScreen { &SROFF::enScreen; }

sub lvScreen {
    my ($self, @rest) = @_;

    # <P></P> spaces around <PRE>
#    $self->{data} = "<P></P><PRE>" . $self->{data} . "</PRE><P></P>\n";
    $self->{data} = "<PRE>" . $self->{data} . "</PRE>\n";

    $self->SROFF::lvScreen(@rest);
}

#
#
#

#sub enLineAnnotation { &SROFF::enLineAnnotation(@_); }
#sub lvLineAnnotation { &SROFF::lvLineAnnotation(@_); }

#
#
#

#sub enHolder { &SROFF::enHolder(@_); }
#sub lvHolder { &SROFF::lvHolder(@_); }

#
#
#

#sub enDrop { &SROFF::enDrop(@_); }
#sub lvDrop { &SROFF::lvDrop(@_); }

#
#
#

#sub enBlockQuote { my ($self, @rest) = @_; $self->SROFF::enBlockQuote(@rest);}

sub lvBlockQuote {
    my ($self, @rest) = @_;

    $self->{data} = "<BLOCKQUOTE>\n" . $self->{data} . "</BLOCKQUOTE>\n";

    $self->SROFF::lvBlockQuote(@rest);
}

#
#
#

#sub enFigure { &SROFF::enFigure(@_); }
#sub lvFigure { &SROFF::lvFigure(@_); }

#
#
#

#sub enFigureTitle { &SROFF::enFigureTitle(@_); }

sub lvFigureTitle {
    my ($self, @rest) = @_;

    $self->{figure}->title ($self->{data});
    $self->{data} = "\n<H4>   " . $self->{figure}->fmtFull . "</H4>\n";

    $self->SROFF::lvFigureTitle(@rest);
}

#
#
#

#sub enFootnote { &SROFF::enFootnote(@_); }

sub lvFootnote {
    my ($self, @rest) = @_;

    # remove paragraph around data
    $self->{data} =~ s/^<P>((.|\n)*)<\/P>\n$/\1/;
    $self->{data} = "(note: $self->{data})";

    $self->SROFF::lvFootnote(@rest);
}

1;
