# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Structure;

package SROFF::HTML;

#
#
#

#sub enStructTitle { &SROFF::enStructTitle(@_); }
#sub lvStructTitle { &SROFF::lvStructTitle(@_); }

#
#
#

#sub enStructSubTitle { &SROFF::enStructSubTitle(@_); }
#sub lvStructSubTitle { &SROFF::lvStructSubTitle(@_); }

#
#
#

#sub enStructDate { &SROFF::enStructDate(@_); }
#sub lvStructDate { &SROFF::lvStructDate(@_); }

#
#
#

#sub enStructAuthor { &SROFF::enStructAuthor(@_); }
#sub lvStructAuthor { &SROFF::lvStructAuthor(@_); }

#
#
#

sub StructTitlePage {
    my ($self, @rest) = @_;
    $self->{data} = "";

    ##
    ## Subject
    ##
    $self->{data} .= "\n<H1 ALIGN=CENTER>$self->{docRef}[0]{title}</H1>\n";
    $self->{data} .= "<H2 ALIGN=CENTER>$self->{docRef}[0]{subTitle}</H2>\n"
	if (defined $self->{docRef}[0]{subTitle});

    ##
    ## Date
    ##
    if (defined $self->{docRef}[0]{date}) {
	$self->{data} .= "\n<H4 ALIGN=CENTER>$self->{docRef}[0]{date}</H4>\n";
    }

    ##
    ## Authors
    ##
    foreach $author (@{$self->{docRef}[0]{authors}}) {
	if ($author->{author} ne "") {
	    $self->{data} = "\n<H4 ALIGN=CENTER>$author->{author}</H4>\n";
	}
	if (defined $author->{affiliation}) {
	    $self->{data} .= "<H4 ALIGN=CENTER>$author->{affiliation}</H4>\n";
	}
    }

    ##
    ## Abstract
    ##
    if (defined ($self->{docRef}[0]{abstract})) {
	$self->{data} .= "\n<H4 ALIGN=CENTER><I>ABSTRACT</I></H4>\n"
	    . "$self->{docRef}[0]{abstract}";
    }

    # Will include other info and copyright
    $self->SROFF::StructTitlePage(@rest);
}

#
# Abstract
#

sub enAbstract {
    my ($self, @rest) = @_;
    $self->SROFF::enAbstract(@rest);
    $self->enBlockQuote(@rest);
}

sub lvAbstract {
    my ($self, @rest) = @_;
    $self->lvBlockQuote(@rest);
    $self->SROFF::lvAbstract(@rest);
}

#
#
#

#sub enSection { &SROFF::enSection(@_); }
#sub lvSection { &SROFF::lvSection(@_); }

#
#
#

#sub enTitle { &SROFF::enTitle(@_); }
sub lvTitle {
    my ($self, @rest) = @_;

    $self->{sectionRefs}[0]{title} = $self->{data};
    $self->{data} = "$self->{sectionRefs}[0]{index}  $self->{data}";
    $self->{data} = "\n<H$#{$self->{sectionNum}}>$self->{data}"
	. "</H$#{$self->{sectionNum}}>\n";

    $self->SROFF::lvTitle(@rest);
}

1;
