# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

package SROFF;

#
# General List semantics
#

sub enList {
    my ($self, @rest) = @_;
    unshift (@{$self->{filling}}, 0);
    unshift (@{$self->{listType}}, "");
    unshift (@{$self->{itemnum}}, 0);
}

sub lvList {
    my ($self, @rest) = @_;
    shift (@{$self->{itemnum}});
    shift (@{$self->{listType}});
    shift (@{$self->{filling}});
}

#
# An ordered or enumerated list
#

sub enOrderedList {
    my ($self, @rest) = @_;
    $self->enList(@rest);
    @{$self->{listType}}[0] = "ordered";
}

sub lvOrderedList {
    my ($self, @rest) = @_;
    $self->lvList(@rest);
}

#
# An itemized or bullet list
#

sub enItemizedList {
    my ($self, @rest) = @_;
    $self->enList(@rest);
    @{$self->{listType}}[0] = "itemized";
}

sub lvItemizedList {
    my ($self, @rest) = @_;
    $self->lvList(@rest);
}

#
# A variable, mark or glossary list
#
sub enVariableList {
    my ($self, @rest) = @_;
    $self->enList(@rest);
    @{$self->{listType}}[0] = "variable";
}

sub lvVariableList {
    my ($self, @rest) = @_;
    $self->lvList(@rest);
}

#
# An item of a list
#
sub enListItem {
    my ($self, @rest) = @_;
    unshift (@{$self->{firstPara}}, 1);
    unshift (@{$self->{parHang}}, 0);
}

sub lvListItem {
    my ($self, @rest) = @_;
    shift (@{$self->{firstPara}});
    shift (@{$self->{parHang}});
    $self->{itemnum}[0] ++;	# Note, this will generally happen
				# after child processing
}

#
# A glossary term or mark for a variable list
#

sub enTerm {
}

sub lvTerm {
}

1;
