# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#
# TROFF output is in `ms' macros.
#

require SROFF;
require SROFF::TROFF::CharEntities;
require SROFF::TROFF::Inline;
require SROFF::TROFF::Lists;
require SROFF::TROFF::Paragraph;
require SROFF::TROFF::Structure;

package SROFF::TROFF;

@ISA = (SROFF);

sub new {
    my $self;

    $self = new SROFF;

    $self->{font}[0] = "R";
    $self->{indent}[0] = 0;

    bless $self;
}

sub Initialize {
    my ($self, @rest) = @_[0];

    $::backslash_in_data = "\\e";

    $self->SROFF::Initialize (@rest);
}

sub PostProcess {
    my ($self, @rest) = @_;

    $self->{data} = $self->{dataStack}[0];
    $self->{data} =~ s/\035([^\035]*)\035/$self->fmtReference($1)/eg;
    $self->{data} =~ s/\n\0\./\n\./g;
    $self->{data} =~ s/\0\./\n\./g;
    $self->{data} =~ s/\n\0\n/\n/g;
    $self->{data} =~ s/\0\n/\n/g;
#    $self->{data} = <<EOF;
#.nr PS 10
#.nr VS 12
#.ds LH
#.ds CH
#.ds RH
#.ds LF Draft
#.ds CF %
#.ds RF Vers. 1.6
#$self->{data}
#EOF

    $self->SROFF::PostProcess (@rest);
}

1;
