# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Inline;

package SROFF::TROFF;

#
# XXX If these inlines are called outside of their original contexts (i.e.
# from within a reference substitution) they stand a high chance of
# `$self->{font}[0]' being wrong.
#

sub InlineItalic {
    my ($self, $str) = @_;

    "\\fI" . $str . "\\f" . $self->{font}[0];
}

#
#
#

#sub enInline { &SROFF::enInline(@_); }
#sub lvInline { &SROFF::lvInline(@_); }

#
#
#

sub enInlineItalic {
    my ($self, @rest) = @_;

    unshift (@{$self->{font}}, "I");
    $self->SROFF::enInlineItalic(@rest);
}

sub lvInlineItalic {
    my ($self, @rest) = @_;

    shift (@{$self->{font}});
    $self->{data} = $self->InlineItalic($self->{data});

    $self->SROFF::lvInlineItalic(@rest);
}

#
#
#

#sub enInlineQuotedItalic { &SROFF::enInlineQuotedItalic(@_); }
#sub lvInlineQuotedItalic { &SROFF::lvInlineQuotedItalic(@_); }

#
#
#

sub enInlineBold {
    my ($self, @rest) = @_;

    unshift (@{$self->{font}}, "I");

    $self->SROFF::enInlineBold(@rest);
}

sub lvInlineBold {
    my ($self, @rest) = @_;

    shift (@{$self->{font}});
    $self->{data} = "\\fB" . $self->{data} . "\\f" . $self->{font}[0];

    $self->SROFF::lvInlineBold(@rest);
}

#
#
#

#sub enInlineQuotedBold { &SROFF::enInlineQuotedBold(@_); }
#sub lvInlineQuotedBold { &SROFF::lvInlineQuotedBold(@_); }

#
#
#

sub enInlineTT {
    my ($self, @rest) = @_;

    unshift (@{$self->{font}}, "(CW");

    $self->SROFF::enInlineTT(@rest);
}


sub lvInlineTT {
    my ($self, @rest) = @_;

    shift (@{$self->{font}});
    $self->{data} = "\\f(CW" . $self->{data} . "\\f" . $self->{font}[0];

    $self->SROFF::lvInlineTT(@rest);
}

#
#
#

#sub enInlineQuotedTT { &SROFF::enInlineQuotedTT(@_); }
#sub lvInlineQuotedTT { &SROFF::lvInlineQuotedTT(@_); }

#
#
#

#sub enInlineQuoted { &SROFF::enInlineQuoted(@_); }

sub lvInlineQuoted {
    my ($self, @rest) = @_;

    if ($self->{quoting}[1]) {
	$self->{data} = "`" . $self->{data} . "'";
    }

    $self->SROFF::lvInlineQuoted(@rest);
}

#
#
#

#sub enInlineDQuoted { &SROFF::enInlineDQuoted(@_); }

sub lvInlineDQuoted {
    my ($self, @rest) = @_;
    if ($self->{quoting}[1]) {
	$self->{data} = "``" . $self->{data} . "''";
    }
    $self->SROFF::lvInlineDQuoted(@rest);
}

#
#
#

#sub enInlineSymbol { &SROFF::enInlineSymbol(@_); }

sub lvInlineSymbol {
    my ($self, @rest) = @_;

    $self->{data} = "<" . $self->{data} . ">";

    $self->SROFF::lvInlineSymbol(@rest);
}

#
#
#

sub URL {
    my ($self, $name, $url) = @_;
    if ($name ne "") {
	$self->{data} = "\\fI$name\\f$self->{font}[0] ($url)";
    } else {
	$self->{data} = $url;
    }
}

1;
