# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Lists;

package SROFF::TROFF;

#
#
#

sub enList {
    my ($self, @rest) = @_;

    $self->SROFF::enList(@rest);

    unshift (@{$self->{indent}}, 5);
}

sub lvList {
    my ($self, @rest) = @_;

    $self->{data} = "\0.RS\n\n"
	. $self->{data} . "\0.RE\n";
    shift (@{$self->{indent}});

    $self->SROFF::lvList(@rest);
}

#
#
#

#sub enOrderedList { &SROFF::enOrderedList(@_); }
#sub lvOrderedList { &SROFF::lvOrderedList(@_); }

#
#
#

#sub enItemizedList { &SROFF::enItemizedList(@_); }
#sub lvItemizedList { &SROFF::lvItemizedList(@_); }

#
# A variable, mark or glossary list
#

#sub enVariableList { &SROFF::enVariableList(@_); }
#sub lvVariableList { &SROFF::lvVariableList(@_); }

#
#
#

#sub enListItem { my ($self, @rest) = @_; $self->SROFF::enListItem(@rest); }

sub lvListItem {
    my ($self, @rest) = @_;

    if ($self->{listType}[0] eq "ordered") {
	$self->{data} = "\0.IP $self->{itemnum})\n$self->{data}\0\n";
    } elsif ($self->{listType}[0] eq "itemized") {
	$self->{data} = "\0.IP \\(bu\n$self->{data}\0\n";
    } else {
	$self->{data} = "\0.LP\n$self->{data}\0\n";
    }

    $self->SROFF::lvListItem(@rest);
}

#
#
#

#sub enTerm { &SROFF::enTerm(@_); }

sub lvTerm {
    my ($self, @rest) = @_;

    $self->{data} = "\0.IP \"\" -5n\n$self->{data}\0.br\n";

    $self->SROFF::lvTerm(@rest);
}

1;
