# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Paragraph;

package SROFF::TROFF;

#
#
#

#sub enParagraph { my ($self, @rest) = @_; $self->SROFF::enParagraph(@rest); }

sub lvParagraph {
    my ($self, @rest) = @_;

    if ($self->{firstPara}[1]) {
	$self->{firstPara}[1] = 0;
	$self->{data} = $self->{data} . "\0\n";
    } else {
	$self->{data} = "\0.LP\n" . $self->{data} . "\0\n";
    }

    $self->SROFF::lvParagraph(@rest);
}

#
#
#

sub enScreen {
    my ($self, @rest) = @_;

    unshift (@{$self->{font}}, "(CW");

    $self->SROFF::enScreen(@rest);
}

sub lvScreen {
    my ($self, @rest) = @_;

    shift (@{$self->{font}});

# XXX override in DTD module
#    if ($::context[1] ne "TSCREEN") {
#	# remove any extra new-lines around data
#	$self->{data} =~ s/^(\s*\n)+//;
#	$self->{data} =~ s/(\n\s*)+$//;
#	$self->{data} = "\\f(CW" . $self->{data} . "\\f" . $self->{font}[0];
#	$self->{data} = "\0.nf\n\n$self->{data}\0.fi\n";
#    }

    $self->SROFF::lvScreen(@rest);
}

#
#
#

#sub enLineAnnotation { &SROFF::enLineAnnotation(@_); }
#sub lvLineAnnotation { &SROFF::lvLineAnnotation(@_); }

#
#
#

#sub enHolder { &SROFF::enHolder(@_); }
#sub lvHolder { &SROFF::lvHolder(@_); }

#
#
#

#sub enDrop { &SROFF::enDrop(@_); }
#sub lvDrop { &SROFF::lvDrop(@_); }

#
#
#

#sub enBlockQuote { my ($self, @rest) = @_; $self->SROFF::enBlockQuote(@rest); }

sub lvBlockQuote {
    my ($self, @rest) = @_;

    $self->{data} = "\0.RS\n$self->{data}\0.RE\n";

    $self->SROFF::lvBlockQuote(@rest);
}

#
#
#

#sub enFigure { &SROFF::enFigure(@_); }
#sub lvFigure { &SROFF::lvFigure(@_); }

#
#
#

#sub enFigureTitle { &SROFF::enFigureTitle(@_); }

sub lvFigureTitle {
    my ($self, @rest) = @_;

    $self->{figure}->title ($self->{data});
    $self->{data} = "\0.LP\n\\fB  " . $self->{figure}->fmtFull
	. "\\f$self->{font}[0]\0.br\n";

    $self->SROFF::lvFigureTitle(@rest);
}

#
#
#

#sub enFootnote { &SROFF::enFootnote(@_); }

sub lvFootnote {
    my ($self, @rest) = @_;

    $self->SROFF::lvFootnote(@rest);
}

1;
