# -*- perl -*-

#    Copyright (C) 1995  Ken MacLeod
#    This file is part of DTD Fragments.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

require SROFF;
require SROFF::Structure;

package SROFF::TROFF;

#
#
#

#sub enStructTitle { &SROFF::enStructTitle(@_); }
#sub lvStructTitle { &SROFF::lvStructTitle(@_); }

#
#
#

#sub enStructSubTitle { &SROFF::enStructSubTitle(@_); }
#sub lvStructSubTitle { &SROFF::lvStructSubTitle(@_); }

#
#
#

#sub enStructDate { &SROFF::enStructDate(@_); }
#sub lvStructDate { &SROFF::lvStructDate(@_); }

#
#
#

#sub enStructAuthor { &SROFF::enStructAuthor(@_); }
#sub lvStructAuthor { &SROFF::lvStructAuthor(@_); }

#
#
#

sub StructTitlePage {
    my ($self, @rest) = @_;
    $self->{data} = "";

    ##
    ## Subject
    ##

    ##
    ## Date
    ##

    ##
    ## Authors
    ##
    foreach $author (@{$self->{docRef}[0]{authors}}) {
	if ($author->{author} ne "") {
	    $self->{data} .= "\0.AU\n$author->{author}\n";
	}
	if (defined $author->{affiliation}) {
	    $self->{data} .= "\0.AI\n$author->{affiliation}\n";
	}
    }

    ##
    ## Abstract
    ##
    if (defined ($self->{docRef}[0]{abstract})) {
	$self->{data} .= "\0.AB\n" . $self->{docRef}[0]{abstract} . "\0.AE\n";
    }

    # Will include other info and copyright
    $self->SROFF::StructTitlePage(@rest);
}

#
# Abstract
#

#sub enAbstract { my ($self, @rest) = @_; $self->SROFF::enAbstract(@rest); }
#sub lvAbstract { my ($self, @rest) = @_; $self->SROFF::lvAbstract(@rest); }

#
#
#

#sub enSection { &SROFF::enSection(@_); }
#sub lvSection { &SROFF::lvSection(@_); }

#
#
#

#sub enTitle { &SROFF::enTitle(@_); }
sub lvTitle {
    my ($self, @rest) = @_;

    $self->{sectionRefs}[0]{title} = $self->{data};
    $self->{data} = "\0.NH $#{$self->{sectionNum}}\n$self->{data}\0\n";

    $self->SROFF::lvTitle(@rest);
}

1;
