#
# This script tests for certain archives of documents and installs them
# into ``this'' directory.  This script requires GNU `zip' (`gzcat')
# and makes some pretty scary assumptions about the archive file names
# and how those archives were created.
#
# I'll comment on a personal pet peeve here, I WISH FOLKS WOULD CREATE
# TAR FILES THAT UNTAR IN `ARCHIVE-VERSION/...'.  Thank you.  (Of
# course, if you hate that, your pet peeve is probably folks who _do_
# do that. :-)
#

ARCHIVE=$HOME/archive

# http://www.w3.org/pub/WWW/MarkUp/html-spec/html-spec-19950804.tar.gz
FILE=$ARCHIVE/html-spec-19950506.tar.gz
if [ -f $FILE ]; then
  mkdir html-spec-19950506
  (cd html-spec-19950506; gzcat $FILE | tar xvof -)
fi

# ftp://ftp.ora.com/pub/davenport/
FILE=$ARCHIVE/docbk23.tar.Z
if [ -f $FILE ]; then
  mkdir docbk23
  (
    cd docbk23; gzcat $FILE | tar xvof -;
    #
    # For some unknown reason, the DocBook Version 2.3 document does
    # not use the DocBook V2.3 DTD and expects entities that the V2.2
    # DTD did not automatically include.  Sigh.
    # 
    sed -e "1s;HaL and O'Reilly//DTD DocBook;Davenport//DTD DocBook V2.3;" <maintdoc.sgm >tmp
    mv tmp maintdoc.sgm
  )
fi

# ftp://ftp.ora.com/pub/davenport/
FILE=$ARCHIVE/docbook.2.2.1.shar.gz
if [ -f $FILE ]; then
  mkdir docbook.2.2.1
  (
    cd docbook.2.2.1; gzcat $FILE | sh
    sed -e 's;SYSTEM "iso-num.gml";PUBLIC "ISO 8879:1986//ENTITIES Numeric and Special Graphic//EN";' \
        -e 's;SYSTEM "iso-pub.gml";PUBLIC "ISO 8879:1986//ENTITIES Publishing//EN";' <ch03.sgm >tmp
    mv tmp ch03.sgm
    sed -e '1s|>$|[<!ENTITY % ISOnum  PUBLIC "ISO 8879:1986//ENTITIES Numeric and Special Graphic//EN"> %ISOnum;<!ENTITY % ISOpub  PUBLIC "ISO 8879:1986//ENTITIES Publishing//EN"> %ISOpub;<!ENTITY % ISOlat1  PUBLIC "ISO 8879:1986//ENTITIES Added Latin 1//EN"> %ISOlat1;]>|' <fullguide.sgm >tmp
    mv tmp fullguide.sgm
  )
fi

# ftp://info.ex.ac.uk/pub/SGML/gf
FILE=$ARCHIVE/gf-0.44.tar.gz
if [ -f $FILE ]; then
  gzcat $FILE | tar xvof -
fi

# ftp://aix1.uottawa.ca/pub/dmeggins
FILE=$ARCHIVE/SGMLSpm-1.02.tar.gz
if [ -f $FILE ]; then
  gzcat $FILE | tar xvof -
fi

# ftp://info.ex.ac.uk/pub/SGML/format
FILE=$ARCHIVE/sgml2latex-format.1.3.tar.Z
if [ -f $FILE ]; then
  mkdir sgml2latex-format-1.3
  (cd sgml2latex-format-1.3; gzcat $FILE | tar xvof -)
fi

# ftp://sunsite.unc.edu/pub/Linux/docs/HOWTO/WRITING
FILE=$ARCHIVE/linuxdoc-sgml-1.2.tar.gz
if [ -f $FILE ]; then
  gzcat $FILE | tar xvof -
fi
