#
SROFF=$HOME/src/test/bin/sroff
TESTDIR=test
MKDIRHIER="mkdir -p"

test -d $TESTDIR || $MKDIRHIER $TESTDIR

# DocBook
if [ -f SGMLSpm/DOC/sgmlspm.sgml ]; then
  DOCS="$DOCS SGMLSpm/DOC/sgmlspm.sgml SGMLSpm/DOC/sgmlspl.sgml"
fi

# Snafu
if [ -f html-spec/html-spec.sgm ]; then
  DOCS="$DOCS html-spec/html-spec.sgm"
fi

# DocBook 2.3
if [ -f docbk23/maintdoc.sgm ]; then
  DOCS="$DOCS docbk23/maintdoc.sgm"
fi

# DocBook 2.2
if [ -f docbook.2.2.1/ch03.sgm ]; then
  DOCS="$DOCS docbook.2.2.1/ch03.sgm docbook.2.2.1/fullguide.sgm"
fi

# Snafu
if [ -f gf-0.44/sgml/snafu.sgml ]; then
  DOCS="$DOCS gf-0.44/doc/snafu.sgml"
  DOCS="$DOCS gf-0.44/doc/gf.sgml"
fi

# Qwertz
if [ -f sgml2latex-format-1.3/doc/qwertz.sgml ]; then
  DOCS="$DOCS sgml2latex-format-1.3/doc/qwertz.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/doc/manual.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/doc/biblio.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/doc/bibintro.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/fax.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/format.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/qtex.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/qroff.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/extract.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/man/man1/biblio.1.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/test/test.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/test/lit.sgml"
  DOCS="$DOCS sgml2latex-format-1.3/test/test.max.sgml"
fi

# Linuxdoc
if [ -f linuxdoc-sgml-1.2/doc/guide.sgml ]; then
  DOCS="$DOCS linuxdoc-sgml-1.2/doc/guide.sgml"
  DOCS="$DOCS linuxdoc-sgml-1.2/doc/example.sgml"
fi

for ii in $DOCS; do
  DIRNAME="$TESTDIR/`echo $ii | sed -e 's|/.*||'`"
  DOCNAME="`basename $ii`"
  BASENAME="`echo $DOCNAME | sed -e 's|\.sgm$||' -e 's|\.sgml||`"
  test -d $DIRNAME || $MKDIRHIER $DIRNAME
  for jj in ascii html troff; do
    echo "---- $ii - $jj ----"
    $SROFF -T $jj -o $DIRNAME/$BASENAME.$jj $ii
  done
done
