# -*- perl -*-

# This is set to replace `sgmls.pl' and the user callbacks in
# `defrag.pl'.  This uses David Megginson's ``SGMLSpm'' Perl module.
#
# The ``attributes'' array from `sgmls.pl' has not been fitted into
# this.  The better way is to pass the current element (`$data') to
# element routines instead of just the element name (`$data->name').
# Maybe next version.

use SGMLS;

sub ParseSGMLS {
    my ($context) = @_;
    my ($this_parse, $this_event);

    $this_parse = new SGMLS(STDIN);

    while ($this_event = $this_parse->next_event) {
	my $type = $this_event->type;
	my $data = $this_event->data;
      SWITCH: {
	  $type eq 'start_element' && do {
	      unshift (@{$context->{dataStack}}, "");
	      $enterElement = "en$map{$data->name}";
	      $context->$enterElement ($data->name);
	      last SWITCH;
	  };
	  $type eq 'end_element' && do {
	      $context->{data} = shift(@{$context->{dataStack}});
	      $leaveElement = "lv$map{$data->name}";
	      $context->$leaveElement ($data->name);
	      ${$context->{dataStack}}[0] .= $context->{data};
	      last SWITCH;
	  };
	  $type eq 'cdata' && do {
	      ${$context->{dataStack}}[0] .= $data;
	      last SWITCH;
	  };
	  $type eq 're' && do {
	      ${$context->{dataStack}}[0] .= "\n";
	      last SWITCH;
	  };
	  $type eq 'sdata' && do {
	      if (defined $entities{$data}) {
		  ${$context->{dataStack}}[0] .= $entities{$data};
	      } else {
		  warn "undefined entity at line $this_event->line: $data\n";
		  ${$context->{dataStack}}[0] .= $data;
	      }
	      last SWITCH;
	  };

	  # otherwise
	  warn "$::prog: event \`$type' not handled\n";
      }
    }
}

1;
